#include "mdh2bin.h"
main(int argc,char **argv)
{
	FILE *fd=fopen(argv[1],"rb");
	float parts[2];
	int faces[3];
	char name[1024];
	int vertex=0;
	int i,n;
	int ret;
	unsigned char *buf;
	unsigned char *ptr2;
	unsigned char *ptr;
	long len;
	int offset;
	int *_n;
	float *_f;

	if (fd) 
	{
		fseek(fd,0,SEEK_END);
		len=ftell(fd);
		fseek(fd,0,SEEK_SET);
		buf=(char *)malloc(len+1);
		ptr=buf;
		fread(buf,len,1,fd);

		if (!memcmp(ptr,MDH_MAGIC,4))
		{
			printf("magic: OK\n");
		} else {
			printf("magic: WRONG\n");
			exit(1);
		}
		ptr=ptr+4;

		while(ptr<buf+len)
		{
			if (ptr[0]<MDH_DINAMIC) {
				_n=ptr+1;
				n=ntohl(*_n);
				offset=1+sizeof(int);
			} else  offset=1;

			switch(ptr[0])
			{
			case MDH_NUMFRAMES:
				printf("\n&NUMFRAMES %d\n",n);
				break;
			case MDH_NUMANIMATIONS:
				printf("\n&NUMANIMATIONS %d\n",n);
				break;
			case MDH_SPEED:
				printf("\n&SPEED %d\n",n);
				break;
			case MDH_TEXTURE:
				memcpy(name,ptr+offset,n);
				name[n]=0;
				printf("\n&TEXTURE %s\n",name);
				ptr=ptr+n;
				break;
			case MDH_VERTEX:
				printf("\n&VERTEX %d\n",n);
				vertex=n;
				break;
			case MDH_FACES:
				printf("\n&FACES %d\n",n);
				for (i=0;i<n;i++)
				{
				_n=ptr+offset;
				faces[0]=*_n;
				_n=ptr+offset+sizeof(int);
				faces[1]=*_n;
				_n=ptr+offset+sizeof(int)*2;
				faces[2]=*_n;
				printf("%d %d %d\n",ntohl(faces[0]),ntohl(faces[1]),ntohl(faces[2]));
				offset+=sizeof(int)*3;
				}
				break;
			case MDH_MAPPARTS:
				printf("\n&MAP_PARTS %d\n",n);
				for (i=0;i<n;i++)
				{
				//fread(parts,sizeof(float)*2,1,fd);
				_f=ptr+offset;
				parts[0]=*_f;
				_f=ptr+offset+sizeof(float);
				parts[1]=*_f;
				printf("%f %f\n",parts[0],parts[1]);
				offset+=sizeof(float)*2;
				}
				break;
			case MDH_MAPFACES:
				printf("\n&MAP_FACES %d\n",n);
				for (i=0;i<n;i++)
				{
				_n=ptr+offset;
				faces[0]=*_n;
				_n=ptr+offset+sizeof(int);
				faces[1]=*_n;
				_n=ptr+offset+sizeof(int)*2;
				faces[2]=*_n;
				//fread(faces,sizeof(int)*3,1,fd);
				printf("%d %d %d\n",ntohl(faces[0]),ntohl(faces[1]),ntohl(faces[2]));
				offset+=sizeof(int)*3;
				}
				break;
			case MDH_DINAMIC:
				printf("\n*D\n");
				for (i=0;i<vertex;i++)
				{
				_f=ptr+offset;
				parts[0]=*_f;
				_f=ptr+offset+sizeof(float);
				parts[1]=*_f;
				_f=ptr+offset+sizeof(float)*2;
				parts[2]=*_f;
				//fread(parts,sizeof(float)*3,1,fd);
				printf("%f %f %f\n",parts[0],parts[1],parts[2]);
				offset+=sizeof(float)*3;
				}
				break;
			case MDH_NEXTFRAME:
				printf("\n.\n");
				for (i=0;i<vertex;i++)
				{
				//fread(parts,sizeof(float)*3,1,fd);

				_f=ptr+offset;
				parts[0]=*_f;
				_f=ptr+offset+sizeof(float);
				parts[1]=*_f;
				_f=ptr+offset+sizeof(float)*2;
				parts[2]=*_f;
				printf("%f %f %f\n",parts[0],parts[1],parts[2]);
				offset+=sizeof(float)*3;
				}
				break;
			case MDH_STATIC:
				printf("\n*\n");
				for (i=0;i<vertex;i++)
				{
				//fread(parts,sizeof(float)*3,1,fd);

				_f=ptr+offset;
				parts[0]=*_f;
				_f=ptr+offset+sizeof(float);
				parts[1]=*_f;
				_f=ptr+offset+sizeof(float)*2;
				parts[2]=*_f;
				printf("%f %f %f\n",parts[0],parts[1],parts[2]);
				offset+=sizeof(float)*3;
				}
				break;
			default:
				printf("OPCODE NOT FOUND %x\n",buf[0]);
			}

			ptr=ptr+offset;

		}
		fclose(fd);
	}else printf("err\n"); 
	exit(0);
}
