#include "Camera.h"


Camera::Camera(char *ruta)
{
	HUD = new Interface("hud.png", "font_big.png", "font_small.tga");
	DNI=-1;
	yawH=0.0f;
	yawV=0.0f;
	load(ruta);
	idLegs=this->getControl(LEGS)->getObject3D()->getTexture();
	idBody=this->getControl(BODY)->getObject3D()->getTexture();
	idHead=this->getControl(HEAD)->getObject3D()->getTexture();
	isThirdView=false;	
}

GL3f Camera::getObjPos()
{
	GL3f objCam;

	if (yawV>1)  yawV =  1;
	if (yawV<-1) yawV = -1;

	// set camera position
	objCam.x=getPos().x+(float)cos(yawH)*(float)cos(yawV);
	objCam.y=getPos().y+(float)sin(yawV);
	objCam.z=getPos().z+(float)sin(yawH)*(float)cos(yawV);

	return objCam;
}

void Camera::setObj(double yawH, double yawV)
{
	this->yawH=yawH;
	this->yawV=yawV;
}

float Camera::getRotation()
{
	return yawH;
}

GL2f Camera::getYaw()
{
	return GL2f(cos(yawH)*cos(yawV),sin(yawH)*sin(yawV));
}

int Camera::getDNI()
{
	return DNI;
}

void Camera::setDNI(int DNI)
{
	this->DNI=DNI;
}

Interface* Camera::getInterface()
{
	return HUD;
}

void Camera::setThirdView (bool state)
{
	isThirdView=state;
}

bool Camera::getThirdView()
{
	return isThirdView;
}

void Camera::swapThirdView()
{
	isThirdView^=1;
}

void Camera::centerV()
{
	yawV = 0.0f;
}

void Camera::setOrientation(double yawH, double yawV)
{
	setObj(yawH,yawV);
}

void Camera::addOrientation (Orientation *orientation)
{
	if (this->yawH >= 2*M_PI) 
		this->yawH -= 2*M_PI; else
	if (this->yawH <= 0.0f)
		this->yawH += 2*M_PI;
 
	this->yawH += orientation->getH();
	this->yawV += orientation->getV();
	if (this->yawV >=  (M_PI/2)*MAX_FACTOR)
		this->yawV =  (M_PI/2)*MAX_FACTOR; else
	if (this->yawV <= -(M_PI/2)*MAX_FACTOR) 
		this->yawV = -(M_PI/2)*MAX_FACTOR;

       if (isThirdView)
               this->yawV = 0.0f;
}

void Camera::addMovement(Movement *mov)
{
	setPos(getPos()+mov->pos);
}
