#ifndef _CAMARA_H_
#define _CAMARA_H_
#include "OpenGLH.h"
#include "Player.h"
#include "Interface.h"
#include "Orientation.h"

/* Maximum factor for vertical camera movement on first person view
** (PI/2 rad - 90 deg). */
#define MAX_FACTOR (float)0.9999f

//Clase encargada de Propertiesar al personaje principal
class Camera:public Player
{
	double yawV, yawH;     //Indica hacia donde mira la cmara
	int DNI;
	Interface *HUD;
	bool isThirdView;

public:
	Camera(char *ruta); //Constructor de la clase
	GL3f getObjPos();  //Cojemos hacia donde mira la cmara
	void setObj(double yawH, double yawV); //Definimos hacia donde mira la cmara
	GL2f getYaw();
	
	int getDNI();

	void setDNI(int DNI);

	Interface *getInterface();
	float getRotation();

	void setThirdView(bool state);
	bool getThirdView();
	void swapThirdView();

	void centerV();
	void setOrientation(double yawH, double yawV);
	void addOrientation(Orientation *o);
	void addMovement(Movement *m);
};

#endif
