/*! \file  ControlsMouse.cpp
 *  \brief ControlsMouse class definition
 */

#include "ControlsMouse.h"

/*!
 * Associates the Camera to this controller and initializes its (ControlsMouse)
 * private values.
 *
 * \param cam the user's game view point (his Camera)
 */
ControlsMouse::ControlsMouse(Camera *cam)
{
	this->cam = cam;
	mouse_speed_x = MOUSE_SPEED_X;
	mouse_speed_y = MOUSE_SPEED_Y;
}

ControlsMouse::~ControlsMouse()
{
}

/*! 
 * Gets the status of the mouse and sets up the camera according to it.
 */
void ControlsMouse::input()
{
	Uint8 buttons;
	int x, y;
	Orientation orientation;

	buttons = SDL_GetRelativeMouseState(&x, &y);

	if (x||y)
	{
		orientation.setH(x*(M_PI/90.0)*mouse_speed_x);
		orientation.setV(-y*(M_PI/90.0)*mouse_speed_y);
		cam->addOrientation(&orientation);
		SDL_WarpMouse(WIDTH/2,HEIGHT/2);
		SDL_PumpEvents();
		SDL_GetRelativeMouseState(&x, &y);
	}
}

#warning Falten els get/set dels valors configurables

