#include "Game.h"
#include "Config.h"

Game::Game(char *modelName,char *mapName)
{
	char nick[100],pass[100],server[100],temp[100];
	int port;

	col=NULL;
	ctr=NULL;
	net=NULL;
	stg=NULL;

	glhRandomize();

	renderScreen=new Render();


if (NETWORK) // must be in Config || Network :??
{
	FILE *fd;

	//fd=fopen(Config::getClientFile(),"rt");
	fd=fopen("config.cli","rt");  // TODO - get config
	if (!fd) {
		printf("Couldn't find config.cli\n");
		killProgram(0);
	} else {
	while(!feof(fd)){
		temp[0]=0;
		fscanf(fd,"%s",temp);
		if (!strcmp(temp,"LOGIN")) {
			fscanf(fd,"%s",nick);
		}
		else if (!strcmp(temp,"PASSWORD")) {
			fscanf(fd,"%s",pass);
		}
		else if (!strcmp(temp,"SERVER")) {
			fscanf(fd,"%s",server);
		}
		else if (!strcmp(temp,"PORT")) {
			fscanf(fd,"%d",&port);
		}
	}
	fclose(fd);
	}
	
	try {
		net=new Networkh(server,nick,pass,port,10240);
	} catch(int e) {
		printf("Unable to connect to remote host (%d)\n",e);
		killProgram(0);
	}

	while (!net->conected()) SDL_Delay(1000);

// XXX ??? #warning Only 'if (NETWORK)' ?
	updateTime = 0;
	updateDelay = UPDATE_DELAY;
}

	/* LOADING */
	glColor3f(1,1,1); // white mask for textures
	drawImage("loading0.png",true);

	/* */
	stg = new Stage(modelName, mapName); 
	col = new Collision(stg);
	ctr = new Controls((Camera *)stg->getMyBody(),stg,col,net);

	if (modelName==0)
	{
		printf("MODEL NAME NOT SET\n");
		killProgram(1);
	}

	/* default position */
	stg->setCamaraPos(GL3f(8,0,-2));

	if (NETWORK)
		net->setStage(stg);

	printf("\n[*] GAME LOOP [*]\n\n");
}


Game::~Game()
{
	delete renderScreen;
	delete stg;
	delete ctr;
	delete col;
	if (NETWORK)
	delete net;

	printf("[<] Game Over\n");
}

void Game::draw()
{
	/* network update */
	if (NETWORK)
		updateNet();

	/* update all stage elements */
	stg->update();

	/* ME */
	stg->getMyBody()->setRotation(stg->getRotation()*180/PI);

	/* I'm walkinn as sin() does */
	renderScreen->setWalkEffect(stg->getWalkEffect());
	renderScreen->setViewMap(stg->getViewMap());

	/* draw stage */
	renderScreen->draw(stg);
}

void Game::updateNet ()
{
	if (SDL_GetTicks() >= updateTime)
	{
		GL3f _posCam = stg->getCamaraPos();
		updateTime = SDL_GetTicks()+updateDelay;
		net->cli_sendMove(_posCam,
			(int)((stg->getMyBody()->getRotation()*180.0f/PI)),
			stg->getMyBody()->getAnimation());
	}
}

