#include "Interface.h"
#include "TGAloader.h"
#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>

Interface::Interface() 
{
};

Interface::Interface(char* hud, char* fontBig, char* fontSmall )
{
	/* load textures */
	font_tid=TGAloader_tid(fontBig);
	thud_tid=TGAloader_tid(hud);
	mira_tid=TGAloader_tid("mira.png");

	/* set default rpg values */
	health   = 100;
	kevlar   = 100;
	helmet   = 100;
	strength = 100;
	defense  = 100;
	aim      = 100;
	velocity = 100;
	munition = 100;
}

Interface::~Interface()  /* ?!?! */
{ 
	health   = 0;
	kevlar   = 0;
	helmet   = 0;
	strength = 0;
	defense  = 0;
	aim      = 0;
	velocity = 0;
	munition = 0;
};


void Interface::putstring(char *s,float x,float y,float r,float g,float b,double size, int type)
{
	int i;

	double xsize=size;
	double ysize=size;
	/*
	   glMatrixMode(GL_MODELVIEW);
	   glLoadIdentity();

	   glMatrixMode(GL_PROJECTION);
	   glLoadIdentity();

	   glEnable(GL_BLEND);
	   glBlendFunc(GL_SRC_COLOR,GL_DST_COLOR);

	   glEnable(GL_TEXTURE_2D);
	*/
	glBindTexture(GL_TEXTURE_2D,font_tid);
	glBegin(GL_QUADS);
	glColor3f(r,g,b);

	for (i=0;i<strlen(s);i++)
	{
		char c=s[i];

		if ((c>='0') && (c<='Z'))
		{
			int numchar;
			if (c<'A') numchar=(int)c-(int)'0';
			else numchar=((int)c-(int)'0')-7;

			int row=numchar/4;
			int col=numchar%4;

			float ox,oy,ex,ey;

			ox=(col)*(1./4.);
			ex=(col+1)*(1./4.);
			oy=(row)*(1./4.);
			ey=(row+1)*(1./4.);

			glTexCoord2f(ox,ey);
			glVertex3f(x+(i*xsize),y,0);

			glTexCoord2f(ex,ey);
			glVertex3f(x+(i+1)*xsize,y,0);

			glTexCoord2f(ex,oy);
			glVertex3f(x+(i+1)*size,y+ysize,0);

			glTexCoord2f(ox,oy);
			glVertex3f(x+i*size,y+ysize,0);
		}
	}
	glEnd();

}

void Interface::paint()
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-1.0, -1.0, 1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE);
	glEnable(GL_TEXTURE_2D);
	// Pintem el fondo del mana i de la vida
	// Pintem la vida
	//glColor4f(1.0f, 1.0f, 1.0f, 0.5f);
	glColor3f(1,1,1);

	// hud
	glBindTexture(GL_TEXTURE_2D, thud_tid);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f);	glVertex2f(-1.0f, -1.0f);
		glTexCoord2f(1.0f, 1.0f);	glVertex2f( 1.0f, -1.0f);
		glTexCoord2f(1.0f, 0.0f);	glVertex2f( 1.0f,  1.0f);
		glTexCoord2f(0.0f, 0.0f);	glVertex2f(-1.0f,  1.0f);
	glEnd();

	// mirilla
	glBindTexture(GL_TEXTURE_2D,mira_tid);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f);	glVertex2f(-0.03f, -0.03f);
		glTexCoord2f(1.0f, 1.0f);	glVertex2f( 0.03f, -0.03f);
		glTexCoord2f(1.0f, 0.0f);	glVertex2f( 0.03f,  0.03f);
		glTexCoord2f(0.0f, 0.0f);	glVertex2f(-0.03f,  0.03f);
	glEnd();
	// Printem la vida
	char buf[100];

	sprintf(buf,"%d",health);
	putstring(buf, -0.84f,-0.65f,1,0,0,0.06,1);
	// Printem el kevlar
	sprintf(buf,"%d",kevlar);
	putstring(buf, -0.84f,-0.78f,1,0,0,0.06,1);
	// Printem el helmet
	sprintf(buf,"%d",helmet);
	putstring(buf, -0.84f,-0.94f,1,0,0,0.06,1);
	// Printem la fora
	sprintf(buf,"%d",strength);
	putstring(buf, -0.49f,-0.925f,1,0,0,0.06,1);
	// Printem la defense
	sprintf(buf,"%d",defense);
	putstring(buf, -0.20f,-0.925f,1,0,0,0.06,1);
	// Printem la aim
	sprintf(buf,"%d",aim);
	putstring(buf, 0.06f,-0.925f,1,0,0,0.06,1);
	// Printem la velocity
	sprintf(buf,"%d",velocity);
	putstring(buf, 0.32f,-0.925f,1,0,0,0.06,1);
	// Printem la munition
	sprintf(buf,"%d",munition);
	putstring(buf, 0.65f,-0.925f,1,0,0,0.06,1);

	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
};

