#include "Material.h"

Material::Material()
{
	float a[4]={0.2,0.2,0.2,1};
	memcpy(amb,a,sizeof(a)); /* AMBIENT */
	float d[4]={0.8,0.8,0.8,1};
	memcpy(dif,d,sizeof(d)); /* DIFFUSE */
	float s[4]={1,1,1,0};
	memcpy(spe,s,sizeof(s)); /* SPECULAR */
	float e[4]={0,0,0,1};
	memcpy(emi,e,sizeof(e)); /* EMISSION */
	shi=0;			 /* SHININESS */
}

void Material::setProperty(int GL, float *rgba)
{
	float *ptr = NULL;
	float *ptr2= NULL;

	switch (GL)
	{
	case GL_AMBIENT:
		ptr=amb; break;
	case GL_DIFFUSE:
		ptr=dif; break;
	case GL_SPECULAR:
		ptr=spe; break;
	case GL_EMISSION:
		ptr=emi; break;
	case GL_AMBIENT_AND_DIFFUSE:
		ptr=amb; break;
		ptr2=dif; break;
		break;
	}

	if (ptr)
	memcpy(ptr,rgba,sizeof(float)*4);

	if (ptr2)
	memcpy(ptr2,rgba,sizeof(float)*4);
}

void Material::setProperty(int GL, float s)
{
	shi=s;
}

void Material::draw()
{
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,amb);
	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,dif);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spe);
	glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,emi);
	glMaterialf (GL_FRONT_AND_BACK,GL_SHININESS,shi);
}
