#ifndef _MATES_H_
#define _MATES_H_

#if WIN32
#include <windows.h>
#ifndef isnan
#define isnan _isnan
#endif
#endif

#include <math.h>
#include <GL/gl.h>
#include "OpenGLH.h"
#include <float.h>

const double PI=3.1415926535897932;

GL3f Cross(GL3f vVector1, GL3f vVector2);
GL3f Vector(GL3f vPoint1, GL3f vPoint2);
float Magnitude(GL3f vNormal);
GL3f Normalize(GL3f vNormal);
GL3f Normal(GL3f vTriangle[]);
float PlaneDistance(GL3f Normal, GL3f Point);
float PointPlaneDistance(GL3f , GLFace*, GL3f*);
bool IntersectedPlane(GL3f vTriangle[], GL3f vLine[]);
double testline(GL3f linia[2], GL3f &pres, GL3f triangle[3]);
float Dot(GL3f vVector1, GL3f vVector2);
float AngleBetweenVectors(GL3f Vector1, GL3f Vector2);
GL3f IntersectionPoint(GL3f vNormal, GL3f vLine[], double distance);
bool InsidePolygon(GL3f vIntersection, GL3f Poly[], long verticeCount);
bool InsideTriangle(GL3f vIntersection, GL3f Poly[]);
bool IntersectedPolygon(GL3f vPoly[], GL3f vLine[], int verticeCount);
int intersect_triangle(double orig[3], double dir[3],
                   double vert0[3], double vert1[3], double vert2[3],
                   double *t, double *u, double *v);
bool pointInsideLine(GL3f point, GL3f line[2] );
float toRadiants(float num);
float toDegrees(float num);
#endif

