#ifndef _NETWORKH_H_
#define _NETWORKH_H_

#if WIN32
	// Cal linkar wsock32.lib
	#include <windows.h>
	#include <winsock.h>
	#include <malloc.h>
	#include <direct.h>
	#define mkdir(str,str2) mkdir(str)
#else
	#include <netinet/in.h>
	#include <unistd.h>
	#include <sys/socket.h>
	#include <netdb.h>
	#include <sys/stat.h>
#endif
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <sys/types.h>
	#include "define.h"
	#include "Stage.h"
	#include "../../config.h"
	#include <SDL/SDL_thread.h>

extern unsigned int crc32(char *buf,long len);
extern char *makeDirs(char *str);
extern void killProgram(int mode);

class Networkh
{
	char *hostname,
		key[4];
	int port,s,bsize;
	Stage *stg;
	char nickSend[30], pass[30];
	bool CONECTED;
	bool RECIVING;
			
private:
	int do_send(int,char*,int);
	int do_recv(int,char*,int);
	void cli_reciveKey();
	void cli_reciveVers();
	void cli_packetErr();
	void cli_reciveTalk();
	void cli_checkFile();
	void cli_saveFile();
	void cli_recivePart();
	void cli_reciveItem();
	void cli_reciveBegin();
	void cli_reciveWeapon();
	void cli_reciveMove();
	void cli_reciveOkOk();
	void cli_reciveJoin();
	void cli_killFlag();
	void cli_reciveShot();
	void cli_reciveRole();
	/* send */
	int cli_sendUser(char *user);
	int cli_sendPass(char *pass);
	int cli_sendOkOk();

public:
	int cli_sendTalk(const char *talk);
	int cli_sendNick(char *nick);
	int cli_sendMove(GL3f pos,int rot, int ani);
	int cli_sendWeap(int weap);
	void cli_sendShot(float x,float y,float z,float vx,float vy, float vz);
	
	int start(void *mmh);
	Stage *getStage();
	void setStage(Stage *stg);
	Networkh(char *hostname="localhost",char *login="anonim", char *pass="null",int port=9999,int bsize=1024);
	~Networkh();

	bool conected();
};

int useThread(void *net);

#endif



