#include "OpenGLH.h"

void glhTranslatef(GL3f position){
	glTranslatef(position.x,position.y,position.z);
}

void glhRotatef(GL3f rotation){
	glRotatef(rotation.x,1,0,0);
	glRotatef(rotation.y,0,1,0);
	glRotatef(rotation.z,0,0,1);
}

void glhScalef(GL3f scale){
	glScalef(scale.x,scale.y,scale.z);
}

void glhVertex3f(GL3f vertex){
	glVertex3f(vertex.x,vertex.y,vertex.z);
}

void gluhLookAt(GL3f pos, GL3f obj, float x, float y, float z){
	gluLookAt(pos.x,pos.y,pos.z,
		      obj.x,obj.y,obj.z,
			  x,y,z);
}


GL3f getBoundingPos(GLBounding bounding)
{
	return GL3f(    (bounding.getXmax()-bounding.getXmin())+bounding.getXmin(),
			(bounding.getYmax()-bounding.getYmin())+bounding.getYmin(),
			(bounding.getZmax()-bounding.getXmin())+bounding.getZmin() );
}

void glEnter2D(int width, int height)
{
  glPushMatrix();
  glMatrixMode( GL_PROJECTION);
  glDisable(GL_DEPTH_TEST);
  glLoadIdentity();
  gluOrtho2D(0,width,0,height);
  glMatrixMode( GL_MODELVIEW);
  glLoadIdentity();
     
}

void glExit2D()
{
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
}

void drawImage(char *file, bool invert)
{
	int err;

	glEnter2D(WIDTH,HEIGHT);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);

	err=chdir(getDirs(file)); 
	if (err) {
		printf("cannot chdir\n");
		return;
	}
	glBindTexture(GL_TEXTURE_2D,TGAloader_tid(file));
	chdir("../..");
	
	glBegin(GL_QUADS);
		if (!invert) glTexCoord2f(1.0f,1.0f);
		else glTexCoord2f(1.0f,0.0f);
		glVertex3f((float)WIDTH,(float)HEIGHT,0.0f);

		if (!invert) glTexCoord2f(0.0f,1.0f);
		else glTexCoord2f(0.0f,0.0f);
		glVertex3f(0.0f,(float)HEIGHT,0.0f);

		if (!invert) glTexCoord2f(0.0f,0.0f);
		else glTexCoord2f(0.0f,1.0f);
		glVertex3f(0.0f,0.0f,0.0f);

		if (!invert) glTexCoord2f(1.0f,0.0f);
		else glTexCoord2f(1.0f,1.0f);
		glVertex3f((float)WIDTH,0.0f,0.0f);
	glEnd();

	glDisable(GL_TEXTURE_2D);
	SDL_GL_SwapBuffers( );

	glExit2D();
}

void glhRandomize()
{
  time_t seconds;
  seconds = time (NULL);
  srand(seconds);
}
