#include "Sky.h"

Sky::Sky() 
{ 	
	x=0.0f;    width=0.0f;
	y=0.0f;    height=0.0f;
	z=0.0f;    length=0.0f; 
}
	
Sky::Sky(float x, float y, float z, float width, float height, float length) 
{
	setDimension(x,y,z,width,height,length); 
}

void Sky::setDimension(float x, float y, float z, float width, float height, float length) 
{
	this->x=x;  this->width=width;
	this->y=y;  this->height=height;
	this->z=z;  this->length=length; 
}

int Sky::loadSky(char *ruta)
{
	FILE *fd;
	char tempo[100];

	chdir(getDirs(ruta));
	//Abrimos el archivo
	fd=fopen (ruta,"r");
	if (!fd) return 0;

	while ( !feof(fd) )
	{
		tempo[0]=0;
		fscanf(fd,"%s",tempo);
		if (!strcmp(tempo,"POS")){
			fscanf(fd,"%f %f %f",&x,&y,&z);
		}
		else if (!strcmp(tempo,"TAM")){
			fscanf(fd,"%f %f %f",&width,&height,&length);
		}
		if (!strcmp(tempo,"TEXT")){
			for (int i=0;i<6 && !feof (fd);i++){
				fscanf(fd,"%s",tempo);
				if (!strcmp(tempo,"BACK")) {
					fscanf(fd,"%s",tempo);
					if(!attachTexture(tempo,BACK_ID)) return 0;
				}
				else if (!strcmp(tempo,"FRONT")){
					fscanf(fd,"%s",tempo);
					if(!attachTexture(tempo,FRONT_ID)) return 0;
				}
				else if (!strcmp(tempo,"BOTTOM")){
					fscanf(fd,"%s",tempo);
					if(!attachTexture(tempo,BOTTOM_ID)) return 0;
				}
				else if (!strcmp(tempo,"TOP")){
					fscanf(fd,"%s",tempo);
					if(!attachTexture(tempo,TOP_ID)) return 0;
				}
				else if (!strcmp(tempo,"LEFT")){
					fscanf(fd,"%s",tempo);
					if(!attachTexture(tempo,LEFT_ID)) return 0;
				}
				else if (!strcmp(tempo,"RIGHT")){
					fscanf(fd,"%s",tempo);
					if(!attachTexture(tempo,RIGHT_ID)) return 0;
				}
			}
		}
	}		

	return 1;
}

// Intern
int Sky::attachTexture(char *name, int pos)
{
	unsigned char *tex;
	tex=0;

	//Inicializamos la textura
	g_Texture[pos]=texture();
	g_Texture[pos].setName(name);

	//Cargo la textura en memoria
	try {
	  	tex=TGAloader(name,&g_Texture[pos].width,&g_Texture[pos].height,&g_Texture[pos].bpp);
	} catch(int err){
		printf("Sky: ERROR %d LOADING TEXTURE\n",err);
			return 0;
	}

	//Compruebo que se ha cargado bien
	if (!tex) return 0;
			
	//Inicalizo los parametros correspondientes a Opengl
	glGenTextures(1,&g_Texture[pos].idTex);
	glBindTexture(GL_TEXTURE_2D, g_Texture[pos].idTex);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);

	if (g_Texture[pos].bpp==32)
	{
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA,
				  g_Texture[pos].width,
				  g_Texture[pos].height,
				  GL_RGBA, GL_UNSIGNED_BYTE,
				  tex);
	} else
	if(g_Texture[pos].bpp==24)
	{
	 	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB,
				  g_Texture[pos].width,
				  g_Texture[pos].height,
				  GL_RGB, GL_UNSIGNED_BYTE,
				  tex);
	} else {
		printf ("Texture %s loaded incorrectly\n",name);
		return 0;
	}

	delete[] tex;
	return 1;
}




