#include "Text2D.h"

Text2D::Text2D()
{
	mapabits=0;
}

Text2D::Text2D(char *file)
{
	loadFont(file);
}

Text2D::~Text2D()
{
	unsigned int foo[1];
	foo[0]  = mapabits;
	glDeleteTextures(1,foo);
}

bool Text2D::loadFont(char *file) 
{
	/* Fuentes texturizadas */
	mapabits = TGAloader_tid( file );

	if (mapabits == 0)
	{
		fprintf(stderr,"Cannot load font texture: %s\n",file);
		return false;
	} else {
		printf("[F] %s\n",file);
	}

	return true;
}

void Text2D::print(char *text,float x,float y, float size)
{
	print(text,x,y,1,1,1,size);
}

void Text2D::print(char *text,float x,float y,float r,float g,float b,float size)
{
	int i;
	
	y = 480-y;
	y = y*HEIGHT/480;
	x = x*WIDTH/640;
	size = size*WIDTH/640;

	glBindTexture (GL_TEXTURE_2D, mapabits);

	glPolygonMode(GL_FRONT, GL_FILL);
	if (TRANSPARENCIA){
		//glEnable(GL_ALPHA_TEST);
		glAlphaFunc(GL_GREATER,0.9);
	}

	if (!glIsEnabled(GL_TEXTURE_2D)) glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	glColor3f(r,g,b);

	for (i=0;i<(int)strlen(text);i++)
	{
		char c=text[i];
		
		int numChar;
		if (c>='0' && c<='9') numChar=(int)c-48;
		else if(c>='A' && c<='Z') numChar=(int)c-55;
		else if(c>='a' && c<='z') numChar=(int)c-87;
		else if(c=='!') numChar=36;
		else if(c=='(' || c=='{') numChar=37;
		else if(c==')' || c=='}') numChar=38;
		else if(c=='?' || c=='') numChar=39;
		else if(c==':') numChar=40;
		else if(c==';') numChar=41;
		else if(c=='-') numChar=42;
		else if(c=='.') numChar=43;
		else if(c=='*') numChar=44;
		else if(c=='_') numChar=45;
		else numChar=-1;

		if (numChar>=0)
		{
			int row=numChar/8;
			int col=numChar%8;

			float ox,oy,ex,ey;

			/* 0.12 is the character size (aprox?) */
			ox=(col)*(1.0f/8.0f);
			ex=(col+1)*(1.0f/8.0f);
			oy=(row)*(1.0f/8.0f);
			ey=(row+1)*(1.0f/8.0f);

			glTexCoord2f(ox,ey);
			glVertex3f(x+(i*size),y,0);

			glTexCoord2f(ex,ey);
			glVertex3f(x+(i+1)*size,y,0);

			glTexCoord2f(ex,oy);
			glVertex3f(x+(i+1)*size,y+size,0);

			glTexCoord2f(ox,oy);
			glVertex3f(x+i*size,y+size,0);
		}
	}
	
	glEnd();

	if (TRANSPARENCIA) glDisable(GL_ALPHA_TEST);
}	

void Text2D::translate(int num, char* palabras)
{
	if (num>=0 && num<=9) {
		palabras[0]=num+48;
		palabras[1]=0;
	}
	else if (num>=10 && num<=35){
		palabras[0]=num+55;
		palabras[1]=num+87;
		palabras[2]=0;
	}
	else if (num==36) {
		palabras[0]='!';	
		palabras[1]=0;
	}
	else if (num==37) {
		palabras[0]='(';	
		palabras[1]='{';
		palabras[2]=0;
	}
	else if (num==38) {
		palabras[0]=')';	
		palabras[1]='}';	
		palabras[2]=0;
	}
	else if (num==39) {
		palabras[0]='?';	
		palabras[1]='';	
		palabras[2]=0;
	}
	else if (num==40) {
		palabras[0]=':';	
		palabras[1]=0;
	}
	else if (num==41) {
		palabras[0]=';';	
		palabras[1]=0;
	}
	else if (num==42) {
		palabras[0]='-';	
		palabras[1]=0;
	}
	else if (num==43) {
		palabras[0]='.';	
		palabras[1]=0;
	}
	else if (num==44) {
		palabras[0]='*';	
		palabras[1]=0;
	}
	else if (num==45) {
		palabras[0]='_';	
		palabras[1]=0;
	}
	else palabras[0]=0;
}

char Text2D::translate(char ch)
{
	char buf[10];
	translate((int)ch,buf);
	return buf[0];
}
			
